

//********      **********
//            :   .   . 
//                 www.servissistemy.narod.ru  www.sokol.mam.by
/*
1.      0...300 . ().
2.  .
3.   .
4.  .
5.           
    LCD.
6.      .
7.     .
8.    PD7      .
9.   : " "      .
10.        .
11.     INT0.
12.      .
13.          PORTC 3-5.
14.         PORTD.0  
        .
15.       ""     
     .
16.       2   
       .
17. -      LCD   
    .
18.          LCD.
19.         "||||||||-----".
20.          .
21.         ,    
         .
22.     1.      
    "+"  "-"       .
23.      LCD   .
24.       .    
                -
	   (      -
	 ). 
25.  INT0    .   -
        .      
	     .
26.        "",     
	eeprom   .       
	eeprom.
27.        .
28.        .
29.        .
30.  LCD   flash.
31.        30 .
32.    "  ".


          INT0
       .
       1   5 .    
      ADC0,     
   ,    6,(6) .  
      .    -
        input_index,
        ADC0...ADC2.
      1   6,(6).    , 
     INT0     .

        , , 
       ,   :
	  - 5 .
	  - 11 2/3 .
	  - 18 1/3 .
		
	6,656mSec (0,2%) -  TCNT0 = 0x30;
	4,992mSec (0,2%) -  TCNT0 = 0x64;
*/


#include <inttypes.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include "m8_128.h"

// LCD 
#include "lcddriver.h"
#include "lcddriver.c"

//  define
#include "avrlibdefs.h"

//  
#include "copyright.c"


//
#define V_REF 5					//  , .
#define F_CPU 8000000UL			// .
#define KAL	60					//  .
#define	zaderzhka 5				//     .
#define sound 30				//        .
#define dobavka -15				/*  ,     
								    1. = 32 .  -
								     (-20...20).*/


#define FIRST_ADC_INPUT 0
#define LAST_ADC_INPUT 2
#define ADC_VREF_TYPE 0x40

//  
#define KEY_OK 		0b1110000
#define KEY_CANCEL  0b1101000
#define KEY_MINUS   0b1011000
#define KEY_PLUS    0b0111000
#define NO_KEY 		0b1111000

//   
#define F __attribute__ ((progmem))
#define E unsigned __attribute__ ((section(" .eeprom")))

// 
#define 	SET_B(x) 	|= (1<<x) 
#define 	CLR_B(x) 	&=~(1<<x) 
#define 	INV_B(x) 	^=(1<<x)


// 
volatile unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];	//  
volatile unsigned char input_index=0;						//    

volatile double temp[3];									//   
volatile unsigned int CALL[3];								// 
volatile unsigned int V[3];									// 
volatile unsigned char KEY, counter;						// 
volatile unsigned int VERH_POROG[3], NIZN_POROG[3];		//     
volatile unsigned int current_time=zaderzhka;				//    ( 1 . = 1 c.)
volatile unsigned int time;									//   ( 1 . = 1 c.)
volatile unsigned char Bright;								// 
volatile unsigned char zader;								// 
volatile unsigned char beep;								//  .
volatile unsigned char trevoga;								// 
volatile unsigned int VERH_ZNACH[3]={0,0,0};				//      
volatile unsigned int NIZN_ZNACH[3]={1023L,1023L,1023L};
volatile unsigned char m;									//   
volatile unsigned char count;								//    

E int E_CALL[3]={1024, 1024, 1024};			//   ROM
E int E_VERH_POROG[3]={888L, 888L, 888L};
E int E_NIZN_POROG[3]={685L, 685L, 685L};			//       ROM
E int E_time=60;								//    ROM ( 1 . = 1 c.)
E char E_SND=0xFF;								//,     
E char E_Bright=151;							//   ROM
E char E_zader=50;								//   EEPROM
 

__attribute__ ((progmem)) const unsigned char SymbolCGRAM1[]=
{
//  1
0b00011111,
0b00000000,
0b00010100,
0b00010100,
0b00010100,
0b00010100,
0b00000000,
0b00011111
};
__attribute__ ((progmem)) const unsigned char SymbolCGRAM2[]=
{
//  2
0b00011111,
0b00000000,
0b00010000,
0b00010000,
0b00010000,
0b00010000,
0b00000000,
0b00011111
};
__attribute__ ((progmem)) const unsigned char SymbolCGRAM3[]=
{
//  3
0b00011111,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00011111
};
__attribute__ ((progmem)) const unsigned char SymbolCGRAM4[]=
{
//  4
0b00011111,
0b00000000,
0b00010101,
0b00010101,
0b00010101,
0b00010101,
0b00000000,
0b00011111
};


void _pic (void)
{
//  ""
 if(beep)		//  
	{
	PORTD CLR_B(0);		// 
	_delay_ms(sound);	//
	PORTD SET_B(0);		// 
	_delay_ms(sound);	//
	PORTD CLR_B(0);		// 
	}
 else
	{
	_delay_ms(sound*2);
	}
}

//   INT0      0
SIGNAL (SIG_INTERRUPT0)
{
TCNT0 = 0x64+dobavka;	//  0    5 mSec.
TCCR0 = 0x04; 			//start timer
input_index = 0;
ADMUX = ADC_VREF_TYPE;
return;
}

//      
SIGNAL (SIG_ADC) 
{
static unsigned char count[3];		// 

adc_data[input_index]=ADCW;			//    

	//       
	if ((adc_data[input_index] > VERH_POROG[input_index])||(adc_data[input_index] < NIZN_POROG[input_index]))
		{
		count[input_index]++;
		}
	else
		{
		count[input_index] = 0;
		};
	if (count[input_index] > zader)
		{
		PORTD CLR_B(7);				//      
		PORTC CLR_B (input_index + 3);	//      
		current_time = time;		//      
		trevoga = 1;				//   
		};
	if (VERH_ZNACH[input_index] < adc_data[input_index])	//   
		{
		VERH_ZNACH[input_index] = adc_data[input_index]; 	//  		
		};
	if (NIZN_ZNACH[input_index] > adc_data[input_index])	//   
		{
		NIZN_ZNACH[input_index] = adc_data[input_index];	//  
		};		
	input_index++;					// 
	if(input_index==3) 
		{
		input_index = 0;
		};
	ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff))+input_index;
		
	return;
}


//    0
SIGNAL (SIG_OVERFLOW0)

{
	ADCSRA =0b11001100;	/* , Bit6ADSC - Start Conversion, 
						Auto Trigger ,   ,
						     16.*/
	TCNT0 = 0x30+dobavka;	//  0 
	return;
}


//    1
SIGNAL (SIG_OVERFLOW1)
{
static char s;
char t;
static char NEW_KEY, OLD_KEY;
static int count, count1;
	
 TCNT1H = 0x3C;			//reload counter high value
 TCNT1L = 0xB0;			//reload counter low value
		
 NEW_KEY = PIND&0b1111000;
		
 if (OLD_KEY == NEW_KEY)
	{
	count++;
	}
 else
	{
	OLD_KEY = NEW_KEY;
	count = 0;
	}; 
 if (count>0) 
	{
	counter = 2;
		
	if(NEW_KEY != NO_KEY)
		{
		KEY = NEW_KEY;
		count1 = 0;
		};
		
	if (count>50) 
		{
		counter = 5;
		if (count>100) 
			{
			counter = 20;
			}
		}
	}
	else 
	{
	counter = 0;
	KEY = NO_KEY;
	};
		
 if(s < 19) s++;	
 else 
 {
	for(t=0;t<3;t++)
	{
	V[t] = adc_data[t]/temp[t];
	};
		
	if(current_time>0) 
	{
	current_time--;
	}
	else 
	{
	PORTD SET_B(7);		//  
	PORTC = 0b00111000;	//  
	};
		
	if(count1<30) count1++;//     (30 )
	else 
	{
	count1 = 0;				//      
	m = 0;
	};
		
	if(beep)				// ,    
		{
			if(trevoga) 
			{
			PORTD INV_B(0); 		//     1 .     
			trevoga = 0;			//    ,     
			}
			else 					//       
			{
			PORTD CLR_B(0);			
			}
		}
		else PORTD CLR_B(0);		// 
	s = 0;
	};
 return;
}


//    
void (*funcptr)(void) = 0x0000;


int main (void)
{
	//  LCD  
	char str1[16]  =  "U1=  0B  U2=  0B";
 
	//  LCD      
	char str2[16]  =  "U3=  0B        .";
	
	//  LCD  :
	char str3[16]  =  "   0 cey";
	
	//  LCD  :
	char str4[16]  =  "  0 .00 ce. ";
	
	//  LCD  :
	char str5[16] =   "    0 BoĿ.    ";
	
volatile unsigned int t;
volatile unsigned char n;
volatile unsigned char i=0;		// 
	//
	cli();
		
	/*    eeprom        
	 (  eeprom)*/
		
		
if ((PIND&0b1111000) == KEY_OK)							//   ""   
	{
	//  eeprom   
	n=0;	
	while(n < 3)
		{
		eeprom_write_word(&E_CALL[n],1024);
		eeprom_write_word(&E_VERH_POROG[n],888);
		eeprom_write_word(&E_NIZN_POROG[n],685);
		n++;
		};
	eeprom_write_byte(&E_Bright,151);
	eeprom_write_byte(&E_zader,50);
	eeprom_write_byte(&E_SND,0xFF);
	eeprom_write_word(&E_time,60);
	};
		
//    eeprom
n = 0;
while(n < 3)
	{
	NIZN_POROG[n] = eeprom_read_word(&E_NIZN_POROG[n]);//    eeprom
	VERH_POROG[n] = eeprom_read_word(&E_VERH_POROG[n]);//   eeprom
	CALL[n] = eeprom_read_word(&E_CALL[n]);			//    eeprom
	n++;
	};
Bright = eeprom_read_byte(&E_Bright);
time = eeprom_read_word(&E_time);						//    eeprom
zader = eeprom_read_byte(&E_zader);
beep = eeprom_read_byte(&E_SND);
		
	//  /
	PORTD= 0b01111000;
	DDRD = 0b10000011;
		
	PORTC= 0b00000000;
	DDRC = 0b00111000;
		
	// 
	_lcd_Display_Init();
	
	//  LCD "" 
	_lcd_LoadGraphSymbols(&SymbolCGRAM1, 1);
	_lcd_LoadGraphSymbols(&SymbolCGRAM2, 2);
	_lcd_LoadGraphSymbols(&SymbolCGRAM3, 3);
	_lcd_LoadGraphSymbols(&SymbolCGRAM4, 4);
	
	// 
	_lcd_ClrScr();
		
		// .
		ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff));	//Vref=5V, PORTA.0 -  	
		ADCSRA =0b10001100;
			
		//  0  1
		TIMSK = 0x05;
			
		TCCR1B = 0x00; //stop
		TCNT1H = 0x3C; //actual value:  20,000Hz (0,0%)
		TCNT1L = 0xB0;
		TCCR1A = 0x00;
		TCCR1B = 0x02; //start Timer ;
		
		//  2- 
		TCCR2 = 0x69;
			
		// Analog Comparator: Off
		ACSR=0x80;
		
	//"" 
	_pic ();
		
	// 
	_lcd_SetPos(0,0);			//  
	_lcd_Print("  SOKOL UZP-3F  ");
		
	_lcd_SetPos(0,1);			//  
	_lcd_Print("S/N 00001 v.1.24");
		
	//     
	for(n=3;n>0;n--)
	{	
		while(OCR2) 
		{
		_delay_us(3000); OCR2--;
		};
		while(OCR2<Bright) 
		{
		_delay_us(3000); OCR2++;
		}
	};		
		
	//   0
	MCUCR = 0b11;
	GIFR = 0b1000000;
	GICR SET_B(INT0);
		
	sei();
		
	//,   
	while (1)
 {
	for(n=0;n<3;n++)
	{		
	temp[n] = (double)CALL[n]/(double)(KAL*V_REF);
	};
 
 
//===========================================================================================	
		
		//   LCD
		
	switch (m)		//  
	{	
	case 0:
		{
		//  
		str1[3]=str1[4]=str1[12]=str1[13]=' ';
			
		//     LCD
		//  U1:
		IntToStr((int)(V[0]),&str1[3],3);
		//  U2:
		IntToStr((int)(V[1]),&str1[12],3);
		
		str2[8]=str2[3]=str2[4]=' ';
		
		//     LCD
		if (current_time)
		{
		str2[12]='0';
		str2[10]='';
		str2[11]='.';
		str2[14]='c';
		
		// 
		IntToStr((int)(current_time/60),&str2[8],2);
		
		// 
		IntToStr((int)(current_time%60),&str2[12],2);
		}
		else
		{
		str2[9] =' ';
		str2[10]='H';
		str2[11]='O';
		str2[12]='P';
		str2[13]='M';
		str2[14]='A';
		};
		//  U3:
		IntToStr((int)(V[2]),&str2[3],3);
			
		//  
		_lcd_SetPos(0,0);
		_lcd_Out(str1,16);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str2,16);
		};
	break;
		
	case 1:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa epx-");//"  -"
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print(" eo  opoa U");//"    U"
		_lcd_Print("1");
		};
	break;
		
	case 2:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa epx-");//"  -"
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print(" eo  opoa U");//"    U"
		_lcd_Print("2");
		};
	break;
		
	case 3:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa epx-");//"  -"
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print(" eo  opoa U");//"    U"
		_lcd_Print("3");
		};
	break;
		
	case 101:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Bepx opo U");//"  U"
		_lcd_Print("1");
			
		IntToStr((int)(VERH_POROG[0]/temp[0]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 102:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Bepx opo U");//"  U"
		_lcd_Print("2");
			
		IntToStr((int)(VERH_POROG[1]/temp[1]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 103:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Bepx opo U");//"  U"
		_lcd_Print("3");
			
		IntToStr((int)(VERH_POROG[2]/temp[2]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 4:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa - ");//"  - "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  eo opoa U");//"    U"
		_lcd_Print("1");
		};
	break;
		
	case 5:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa - ");//"  - "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  eo opoa U");//"    U"
		_lcd_Print("2");
		};
	break;
		
	case 6:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" caoa - ");//"  - "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  eo opoa U");//"    U"
		_lcd_Print("3");
		};
	break;
		
	case 104:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" H opo U");//"   U"
		_lcd_Print("1");
			
		IntToStr((int)(NIZN_POROG[0]/temp[0]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 105:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" H opo U");//"   U"
		_lcd_Print("2");
			
		IntToStr((int)(NIZN_POROG[1]/temp[1]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 106:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" H opo U");//"   U"
		_lcd_Print("3");
			
		IntToStr((int)(NIZN_POROG[2]/temp[2]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 7:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("  caoa pe-");//"   -"
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("e oe ");//"  "
		};
	break;
		
	case 107:
		{
		str4[1]=' '; str4[8]='0';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Bpe oe");//" "
			
		// 
		IntToStr((int)(time/60),&str4[1],2);
		
		// 
		IntToStr((int)(time%60),&str4[8],2);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str4,16);
		};
	break;
		
	case 8:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("   ocpoa   ");//"      "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  apǶe  U");//"    U"
		_lcd_Print("1");
		};
	break;
		
	case 108:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" ocpoa U");//"  U"
		_lcd_Print("1: ");
			
		// U1    LCD
		IntToStr((int)(adc_data[0]/temp[0]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 9:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("   ocpoa   ");//"      "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  apǶe  U");//"    U"
		_lcd_Print("2");
		};
	break;
		
	case 109:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" ocpoa U");//"  U"
		_lcd_Print("2: ");
			
		// U2    LCD
		IntToStr((int)(adc_data[1]/temp[1]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 10:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("   ocpoa   ");//"      "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("  apǶe  U");//"    U"
		_lcd_Print("3");
		};
	break;
		
	case 110:
		{
		str5[2]=str5[3]=str5[4]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" ocpoa U");//"  U"
		_lcd_Print("3: ");
			
		// U3    LCD
		IntToStr((int)(adc_data[2]/temp[2]),&str5[2],3);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str5,16);
		};
	break;
		
	case 11:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Hacpoa ya ");//"  "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("      ");
		_lcd_Print("      ");
		_lcd_Print("      ");
		};
	break;
		
	case 111:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("Hacpoa ya ");//"  "
			
		_lcd_SetPos(0,1);			//  
		
		_lcd_Print("      ");
			
		if(beep)	
		{
		
		_lcd_Print(" B");//" "
		}
		else 
		{
		_lcd_Print("B");		//""
		};
			
		_lcd_Print("KEH  "); 		//"    "
		};
	break;
		
	case 12:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("    poc     ");//"         "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("   oce    ");//"       "
		};
	break;
		
	case 112:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("    poc     ");//"         "
			
		//   -  
		_lcd_SetPos(0,1);
			
		n=0;	
		t=Bright+1;
		while(t>15)
			{
			t-=16;
			_lcd_WriteDataByteToDisplayRAM(0x04);//"|||"
			n++;
			};
		if(t>10)
			{
			_lcd_WriteDataByteToDisplayRAM(0x01);//"||-"
			n++;
			}
			else 
			{
				if(t>5)
				{
				_lcd_WriteDataByteToDisplayRAM(0x02);//"|--"
				n++;
				}
			};
		for(;n<16;n++) _lcd_WriteDataByteToDisplayRAM(0x03);//"---"		
		};
	break;
		
	case 13:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print("    aepa    ");//"        "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("   oe   ");//"      "
		};
	break;
		
	case 113:
		{
		str3[0]=str3[1]=str3[2]=' ';
			
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" aepa o: ");//"  : "
			
		// U3    LCD
		IntToStr((int)(zader*20),&str3[0],4);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str3,16);
		};
	break;
		
	case 14:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" pocop oo-");//"  -"
   			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("e apǶe");//" "
		};
	break;
		
	case 114:
		{
		//  
		str1[3]=str1[4]=str1[12]=str1[13]=' ';			
		str2[8]=str2[3]=str2[4]=' ';
		str2[9]=str2[10]=' ';
			
		if(i)
			{
			//     LCD
			//  U1:
			IntToStr((int)(VERH_ZNACH[0]/temp[0]),&str1[3],3);
			//  U2:
			IntToStr((int)(VERH_ZNACH[1]/temp[1]),&str1[12],3);
				
			str2[11]='M';
			str2[12]='A';
			str2[13]='K';
			str2[14]='C';
				
			//  U3:
			IntToStr((int)(VERH_ZNACH[2]/temp[2]),&str2[3],3);
			}
		else
			{
			//     LCD
			//  U1:
			IntToStr((int)(NIZN_ZNACH[0]/temp[0]),&str1[3],3);
			//  U2:
			IntToStr((int)(NIZN_ZNACH[1]/temp[1]),&str1[12],3);
				
			str2[11]=' ';
			str2[12]='M';
			str2[13]='';
			str2[14]='H';
				
			//  U3:
			IntToStr((int)(NIZN_ZNACH[2]/temp[2]),&str2[3],3);
			};
			
		//  
		_lcd_SetPos(0,0);
		_lcd_Out(str1,16);
			
		//  
		_lcd_SetPos(0,1);
		_lcd_Out(str2,16);
		};
	break;
		
	case 15:
		{
		_lcd_SetPos(0,0);			//  
		_lcd_Print(" Cee o - ");//"   - "
			
		_lcd_SetPos(0,1);			//  
		_lcd_Print("popopae:   ");//":   "
		};
	break;
		
	case 115:
		{
		_copyright();
		m=0;
		};
	break;			
	};
	
	
	
//===========================================================================================		
		
				//  
					
		switch (KEY)
		{
			case KEY_OK:
			{
			_pic ();			//  
			switch (m) 
					{
					case 0:			//  
					m=1;
					break;
						
					case 1:			//    1
					m=101;
					break;
						
					case 2:			//    2
					m=102;
					break;
						
					case 3:			//    3
					m=103;
					break;
						
					case 101:		//   
					eeprom_write_word(&E_VERH_POROG[0], VERH_POROG[0]);
					m=1;
					break;
						
					case 102:		//   
					eeprom_write_word(&E_VERH_POROG[1], VERH_POROG[1]);
					m=2;
					break;
						
					case 103:		//   
					eeprom_write_word(&E_VERH_POROG[2], VERH_POROG[2]);
					m=3;
					break;
						
					case 4:			//    1
					m=104;
					break;
						
					case 5:			//    2
					m=105;
					break;
						
					case 6:			//    3
					m=106;
					break;
						
					case 104:		//    1
					eeprom_write_word(&E_NIZN_POROG[0], NIZN_POROG[0]);
					m=4;
					break;
						
					case 105:		//    2
					eeprom_write_word(&E_NIZN_POROG[1], NIZN_POROG[1]);
					m=5;
					break;
						
					case 106:		//    3
					eeprom_write_word(&E_NIZN_POROG[2], NIZN_POROG[2]);
					m=6;
					break;
						
					case 7:			//    
					m=107;
					break;
						
					case 107:		//    
					eeprom_write_word(&E_time, time);
					m=7;
					break;
						
					case 8:			//  U1
					m=108;
					break;
						
					case 108:		//  U1
					eeprom_write_word(&E_CALL[0], CALL[0]);
					m=8;
					break;
						
					case 9:			//  U2
					m=109;
					break;
						
					case 109:		//  U5
					eeprom_write_word(&E_CALL[1], CALL[1]);
					m=9;
					break;
						
					case 10:		//  U3
					m=110;
					break;
						
					case 110:		//  U3
					eeprom_write_word(&E_CALL[2], CALL[2]);
					m=10;
					break;
						
					case 11:		//  
					m=111;
					break;
						
					case 111:		//  
					eeprom_write_byte(&E_SND,beep);
					m=11;
					break;
						
					case 12:		//   LCD
					m=112;
					break;
						
					case 112:		//   LCD
					eeprom_write_byte(&E_Bright,Bright);
					m=12;
					break;
						
					case 13:		//   
					m=113;
					break;
						
					case 113:		//   
					eeprom_write_byte(&E_zader,zader);
					m=13;
					break;
						
					case 14:		//   
					m=114;
					break;
						
					case 114:		//    
					m=14;
					break;
						
					case 15:		//    
					m=115;
					break;
					};
			};
			break;
					
			case KEY_CANCEL:
			{
			_pic ();			//  	
				if(m<100 && m)
				{
				m=0;
				}
				else
				{
				switch (m) 
					{
					case 0:			//
					funcptr(); 		//   ,    
					break;
						
					case 101:		//      
					VERH_POROG[0] = eeprom_read_word(&E_VERH_POROG[0]);
					m=1;
					break;
						
					case 102:		//      
					VERH_POROG[1] = eeprom_read_word(&E_VERH_POROG[1]);
					m=2;
					break;
						
					case 103:		//      
					VERH_POROG[2] = eeprom_read_word(&E_VERH_POROG[2]);
					m=3;
					break;
						
					case 104:		//      
					NIZN_POROG[0] = eeprom_read_word(&E_NIZN_POROG[0]);
					m=4;
					break;
						
					case 105:		//      
					NIZN_POROG[1] = eeprom_read_word(&E_NIZN_POROG[1]);
					m=5;
					break;
						
					case 106:		//      
					NIZN_POROG[2] = eeprom_read_word(&E_NIZN_POROG[2]);
					m=6;
					break;
						
					case 107:		//      
					time = eeprom_read_word(&E_time);		
					m=7;
					break;
						
					case 108:		//      
					CALL[0] = eeprom_read_word(&E_CALL[0]);
					m=8;
					break;
						
					case 109:		//      
					CALL[1] = eeprom_read_word(&E_CALL[1]);	
					m=9;
					break;
						
					case 110:		//      
					CALL[2] = eeprom_read_word(&E_CALL[2]);
					m=10;
					break;
						
					case 111:		//   
					beep = eeprom_read_byte(&E_SND);
					m=11;
					break;
						
					case 112:		//     LCD
					Bright = eeprom_read_byte(&E_Bright);
					OCR2=Bright;
					m=12;
					break;
						
					case 113:		//    
					zader = eeprom_read_byte(&E_zader);
					m=13;
					break;
						
					case 14:		//   
					m=114;
					break;
						
					case 114:		//    
					for(n=0;n<3;n++)
					{
					VERH_ZNACH[n] = 0;
					NIZN_ZNACH[n] = 1023L;					
					};
					m=14;
					break;
					}
				}
			};
			break;
				
			case KEY_MINUS:
			{
			_pic ();			//  
				if(m>1 && m<100)		//    
				{
					m--;				// 
				}
				else
				{		
					for( ;counter>1;counter--)
						{
							switch (m) 
							{
							case 101:		//  
							if (VERH_POROG[0] > 512) VERH_POROG[0]--;
							break;
								
							case 102:		//  
							if (VERH_POROG[1] > 512) VERH_POROG[1]--;
							break;
								
							case 103:		//  
							if (VERH_POROG[2] > 512) VERH_POROG[2]--;
							break;
								
							case 104:		//  
							if (NIZN_POROG[0] > 512) NIZN_POROG[0]--;
							break;
								
							case 105:		//  
							if (NIZN_POROG[1] > 512) NIZN_POROG[1]--;
							break;
								
							case 106:		//  
							if (NIZN_POROG[2] > 512) NIZN_POROG[2]--;
							break;
								
							case 107:		//  
							if (time > 10) time--;
							break;
								
							case 108:		//   U1
							if (CALL[0] < 1500) CALL[0]++;
							break;
								
							case 109:		//   U2
							if (CALL[1] < 1500) CALL[1]++;
							break;
								
							case 110:		//   U3
							if (CALL[2] < 1500) CALL[2]++;
							break;
								
							case 111:		// 
							beep=0xFF^beep;
							break;
								
							case 112:		//   LCD
							if(Bright>1) 
							{
							Bright--; OCR2=Bright;
							};
							break;
								
							case 113:		// 
							if(zader>0) 
							{
							zader--;
							};
							break;
								
							case 114:		//  
							i = i^0xFF;
							break;
							}
					}
				};
			break;
			}
				
			case KEY_PLUS:
			{
			_pic ();			//  
				if(m>0 && m<15)		//    
				{
					m++;				// 
				}
				else
				{		
					for( ;counter>1;counter--)
						{
							switch (m) 
							{
								
							case 101:		//  
							if (VERH_POROG[0] < 1000) VERH_POROG[0]++;
							break;
								
							case 102:		//  
							if (VERH_POROG[1] < 1000) VERH_POROG[1]++;
							break;
								
							case 103:		//  
							if (VERH_POROG[2] < 1000) VERH_POROG[2]++;
							break;
								
							case 104:		//  
							if (NIZN_POROG[0] < 1000) NIZN_POROG[0]++;
							break;
								
							case 105:		//  
							if (NIZN_POROG[1] < 1000) NIZN_POROG[1]++;
							break;
								
							case 106:		//  
							if (NIZN_POROG[2] < 1000) NIZN_POROG[2]++;
							break;
								
							case 107:		//  
							if (time < 3600) time++;
							break;
								
							case 108:		//   U1
							if (CALL[0] > 500) CALL[0]--;
							break;
								
							case 109:		//   U2
							if (CALL[1] > 500) CALL[1]--;
							break;
								
							case 110:		//   U3
							if (CALL[2] > 500) CALL[2]--;
							break;
								
							case 111:		// 
							beep=0xFF^beep;
							break;
								
							case 112:		//   LCD
							if(Bright<255) 
							{
							Bright++; OCR2=Bright;
							};
							break;
								
							case 113:		// 
							if(zader< 250) 
							{
							zader++;
							};
							break;
								
							case 114:		//  
							i = i^0xFF;
							break;
							}
					}	
				};
			break;
			}
		};
		KEY = NO_KEY;
		counter = 0;
 }
}
